// a100dll.cpp:      DLL.
#include "stdafx.h"
#include "a100Dll.h"

//*************************************************************
//*****************************************
//*************************************************************

//**********************A100*Protocol**************************
/*_DLLAPI const int data_array_length = 4;
_DLLAPI const int command_packet_length = 12;*/

typedef struct a100CommandStruct
{
	unsigned char dest;
	unsigned char source;
	unsigned char code;
	unsigned char param;
	unsigned char status;
	unsigned char errors;
	unsigned char data[DATA_COUNT_BYTE];
} a100commandstruct;

a100commandstruct a100_sended_command_var;
a100commandstruct a100_readed_command_var;

//*******************Asynchronous I/O Thread*******************
HANDLE				hRwThread;
DWORD 				idRwThread;
volatile HANDLE		hReadWriteDataEvent;	//       

const unsigned int 	rwthread_stop_wait = 1000;		//      /  .

DWORD WINAPI serialPortRwThreadMain(void* pParam);

//*******************Serial*port*******************************
volatile typeinterfacestate	serial_port_state = INTERFACE_CLOSE_STATE;

int serial_port_read_data_timeout = 0;
int serial_port_write_data_timeout = 0;

volatile HANDLE hSerialPort = 0;

OVERLAPPED ov_waitcommevent;
OVERLAPPED ov_writefile;
OVERLAPPED ov_readfile;

DCB serial_port_new_param;
DCB	serial_port_old_param;

COMMTIMEOUTS serial_port_new_timeouts;
COMMTIMEOUTS serial_port_old_timeouts;
DWORD serial_port_old_evt_mask;

unsigned char send_command_buf[PACKET_LENGTH_BYTE];
unsigned char recv_command_buf[PACKET_LENGTH_BYTE];

//**********************Time*temp*var**************************
int write_data_time = 0;
int read_data_time = 0;

//*************************************************************
//*********************************************
//*************************************************************

//**********************A100*Protocol**************************
unsigned char CRCbit7(const unsigned char buffer_arg[], int length);

void a100ClearAllFields(a100commandstruct &temp_a100_command);

bool  a100CommandFromBuffer(const unsigned char buffer_arg[], a100commandstruct &temp_a100_command);
bool a100CommandToBuffer(unsigned char buffer_arg[], const a100commandstruct &temp_a100_command);

//*******************Asynchronous I/O Thread*******************
void hasReceivedData(int n_bytes_recv, int error);
void hasTransmittedData(int n_bytes_tran, int error);

pA100CallBackFunc userCallBackFunc = NULL;

//*******************Serial*port*******************************
bool writeSerialPortData();

//*************************************************************
//**********************A100*Protocol**************************
//*************************************************************
void a100ClearAllFields(a100commandstruct &temp_a100_command)
{
	temp_a100_command.dest = 0;
	temp_a100_command.source = 0;
	temp_a100_command.code = 0;
	temp_a100_command.param = 0;
	temp_a100_command.status = 0;
	temp_a100_command.errors = 0;
	memset(temp_a100_command.data, 0, DATA_COUNT_BYTE);
}

unsigned char CRCbit7(const unsigned char buffer_arg[], int length) 
{
	unsigned char k;
	unsigned char crc = 0;

	for(int i = 0; i < length; ++i)
	{
		k = buffer_arg[i];
		for(int j = 0; j < 8; j++)
		{
			crc <<= 1;
			if(k & 1) crc |= 1;
			k >>= 1;
			if(crc & 128) crc^=1+8;
		}
	}
	crc &= 127;
	return crc;
} 

bool  a100CommandFromBuffer(const unsigned char buffer_arg[], a100commandstruct &temp_a100_command)
{
	if (buffer_arg == NULL) return false;

	if((buffer_arg[0] & 128) != 128) return false;

	for(int j = 1; j < PACKET_LENGTH_BYTE-1; ++j)
		if(buffer_arg[j] & 128) return false;

	if(buffer_arg[PACKET_LENGTH_BYTE-1] != CRCbit7(buffer_arg, PACKET_LENGTH_BYTE-1)) return false;
	
	temp_a100_command.dest = buffer_arg[0];
	temp_a100_command.source = buffer_arg[1];
	temp_a100_command.code = buffer_arg[2];
	temp_a100_command.param = buffer_arg[3];
	temp_a100_command.status = buffer_arg[4];
	temp_a100_command.errors = buffer_arg[5];
	memcpy(temp_a100_command.data, buffer_arg+6, DATA_COUNT_BYTE);

	if(buffer_arg[6+DATA_COUNT_BYTE] & 1)	temp_a100_command.param |= 128;
	if(buffer_arg[6+DATA_COUNT_BYTE] & 2)	temp_a100_command.status |= 128;
	if(buffer_arg[6+DATA_COUNT_BYTE] & 4)	temp_a100_command.errors |= 128;
	
	for(int j = 3; j < 7; ++j)
		if(buffer_arg[6+DATA_COUNT_BYTE] & (1<<j))
			temp_a100_command.data[j-3] |= 128;
	
	return true;
}

bool a100CommandToBuffer(unsigned char buffer_arg[], const a100commandstruct &temp_a100_command)
{
	if (buffer_arg == NULL) return false;

	memset(buffer_arg, 0, PACKET_LENGTH_BYTE);

	buffer_arg[0] = temp_a100_command.dest | 128;
	buffer_arg[1] = temp_a100_command.source & 127;
	buffer_arg[2] = temp_a100_command.code & 127;
	buffer_arg[3] = temp_a100_command.param & 127;
	buffer_arg[4] = temp_a100_command.status & 127;
	buffer_arg[5] = temp_a100_command.errors & 127;
		
	for(int j = 0; j < DATA_COUNT_BYTE; ++j)
		buffer_arg[6+j] = temp_a100_command.data[j] & 127;

	buffer_arg[6+DATA_COUNT_BYTE] = 0;
	if (temp_a100_command.param & 128) buffer_arg[6+DATA_COUNT_BYTE] |= 1 ;
	if (temp_a100_command.status & 128) buffer_arg[6+DATA_COUNT_BYTE] |= 2 ;
	if (temp_a100_command.errors & 128) buffer_arg[6+DATA_COUNT_BYTE] |= 4 ;
		
	for(int j = 3; j < 7; ++j)
		if (temp_a100_command.data[j-3] & 128) buffer_arg[6+DATA_COUNT_BYTE] |= (1<<j);
		
	buffer_arg[PACKET_LENGTH_BYTE-1] = CRCbit7(buffer_arg, PACKET_LENGTH_BYTE-1);

	return true;
}

_DLLAPI unsigned int a100DataToUInt(const unsigned char data_arr[])
{
	if (data_arr == NULL)
	{
		std::cerr<<"\n a100DataToInt() data_arr error";
		return 0;
	}

	unsigned int arg_val = 0;
	if (sizeof(arg_val) < DATA_COUNT_BYTE)
	{
		std::cerr<<"\n a100DataToInt() error not enought var length "<<sizeof(arg_val)<<"unsigned char < "<<DATA_COUNT_BYTE<<"unsigned char \n";
		return 0;
	}

	memcpy(&arg_val, data_arr, DATA_COUNT_BYTE);
	return arg_val; 
}

_DLLAPI bool a100UIntToData(const unsigned int arg_val, unsigned char data_arr[])
{
	if (data_arr == NULL)
	{
		std::cerr<<"\n a100IntToData() data_arr error";
		return false;
	}

	if (sizeof(arg_val) > DATA_COUNT_BYTE)
	{
		std::cerr<<"\n a100IntToData() error  not enought var length "<<sizeof(arg_val)<<"unsigned char > "<<DATA_COUNT_BYTE<<"unsigned char \n";
		return false;
	}

	memcpy(data_arr, &arg_val, sizeof(arg_val));

	return true;
}

_DLLAPI float a100DataToFloat(const unsigned char data_arr[])
{
	if (data_arr == NULL)
	{
		std::cerr<<"\n a100DataToFloat() data_arr error";
		return 0.0;
	}

	float div = 1.0;
	float arg_val = 0.0;
	unsigned char data_temp[DATA_COUNT_BYTE];

	memcpy(data_temp, data_arr, DATA_COUNT_BYTE);

	for(int i = 0; i < data_temp[DATA_COUNT_BYTE-1]; ++i)
		div *= 10;

	if ((data_temp[DATA_COUNT_BYTE-2] & 128) == 128)
	{
		for (int i = 0; i < DATA_COUNT_BYTE-1; ++i)
			data_temp[i] = (~data_temp[i]) & 255;

		for (int i = 0; i < DATA_COUNT_BYTE-1; ++i)
			arg_val += data_temp[i] << (8*i);

		(++arg_val) /= (div*(-1));

		return arg_val;
	} else
		{
			for (int i = 0; i < DATA_COUNT_BYTE-1; ++i)
				arg_val += data_temp[i] << (8*i);
			
			arg_val /= div;

			return arg_val;
		}
}

_DLLAPI bool a100FloatToData(const float arg_val, unsigned char float_point_count, unsigned char data_arr[])
{
	if (data_arr == NULL)
	{
		std::cerr<<"\n a100FloatToData() data_arr error";
		return false;
	}

	unsigned char uch;
	float mant_float = arg_val;
	
	if (float_point_count > 3) float_point_count = 3;

	for(int i = 0; i < float_point_count; ++i)
		mant_float *= 10;
	
	unsigned int mant_int = 0;
	if (mant_float < 0) mant_int = (unsigned int)(mant_float - 0.5);
		else mant_int = (unsigned int)(mant_float + 0.5);

	uch = mant_int / 0x10000;
	data_arr[2] = uch;
	
	mant_int = mant_int % 0x10000;
	uch = mant_int / 0x100;
	data_arr[1] = uch;
	
	mant_int = mant_int % 0x100;
	uch = mant_int;
	data_arr[0] = uch;

	data_arr[3] = float_point_count;

	return true;
}

//*************************************************************
//*******************Asynchronous I/O Thread*******************
//*************************************************************

void hasReceivedData(int n_bytes_recv, int error)
{
	if (userCallBackFunc == NULL)
	{
		serial_port_state = INTERFACE_IDLE_STATE;
		std::cerr<<"\n CallBackFunc not defined";
		return;
	}

	if (error == 0)
	{
		a100ClearAllFields(a100_readed_command_var);
		
		if (a100CommandFromBuffer(recv_command_buf, a100_readed_command_var)) 
			(*userCallBackFunc)(a100_readed_command_var.dest, a100_readed_command_var.source, a100_readed_command_var.code, a100_readed_command_var.param, a100_readed_command_var.status, a100_readed_command_var.errors, a100_readed_command_var.data, error);
		else 
			(*userCallBackFunc)(a100_sended_command_var.source, a100_sended_command_var.dest, a100_sended_command_var.code, a100_sended_command_var.param, 0, 0, a100_sended_command_var.data, 5);
	} 
	else
		{
			(*userCallBackFunc)(a100_sended_command_var.source, a100_sended_command_var.dest, a100_sended_command_var.code, a100_sended_command_var.param, 0, 0, a100_sended_command_var.data, error);
		}
	
	serial_port_state = INTERFACE_IDLE_STATE;

	#ifdef _DEBUG_ 
		std::cerr<<"\n hasReceivedData n_bytes_recv = "<<n_bytes_recv<<" bytes error = "<<error; 
	#endif
}

void hasTransmittedData(int n_bytes_tran, int error)
{
	if (userCallBackFunc == NULL)
	{
		serial_port_state = INTERFACE_IDLE_STATE;
		std::cerr<<"\n CallBackFunc not defined";
		return;
	}

	if (error == 0)
	{
		serial_port_state = INTERFACE_READ_STATE;
	} else 
		{		
			(*userCallBackFunc)(a100_sended_command_var.source, a100_sended_command_var.dest, a100_sended_command_var.code, a100_sended_command_var.param, 0, 0, a100_sended_command_var.data, error);
			serial_port_state = INTERFACE_IDLE_STATE;		
		}

	#ifdef _DEBUG_ 
		std::cerr<<"\n hasTransmittedData n_bytes_tran "<<n_bytes_tran<<" bytes error = "<<error; 
	#endif
}

DWORD WINAPI serialPortRwThreadMain(void* pParam)
{
	DWORD comm_mask = 0;
	DWORD temp_var = 0;
	DWORD wait_result = 0;
	DWORD transmitted_bytes_count = 0;
	DWORD received_bytes_count = 0;

	COMSTAT comstat_clr_comm;
	DWORD temp_clr_comm;

	bool read_first_word_ok;
	bool read_all_words_ok;

	while(true)
	{
		if (serial_port_state == INTERFACE_CLOSE_STATE) 
		{
			#ifdef _DEBUG_ 
				std::cerr<<"\n serialPortRwThreadMain close interface before ReadWriteDataEvent"; 
			#endif
			
			break; 
		}
		
		#ifdef _DEBUG_ 
			std::cerr<<"\n serialPortRwThreadMain BEGIN";
		#endif

		if (WaitForSingleObject(hReadWriteDataEvent, INFINITE) == WAIT_OBJECT_0)
		{
			ResetEvent(hReadWriteDataEvent);

			if (serial_port_state == INTERFACE_CLOSE_STATE) 
			{ 
				#ifdef _DEBUG_ 
					std::cerr<<"\n serialPortRwThreadMain close interface after ReadWriteDataEvent"; 
				#endif
				break;	
			}
			
			/********************INTERFACE_WRITE_STATE********************/
			if (serial_port_state == INTERFACE_WRITE_STATE)
			{				
				#ifdef _DEBUG_ 
					std::cerr<<"\n serialPortRwThreadMain INTERFACE_WRITE_STATE";
				#endif

				#ifdef _RTS_DISABLE_
					EscapeCommFunction(hSerialPort, SETRTS);
				#endif

				#ifdef _DEBUG_TIME_SHOW_
					write_data_time = timeGetTime();
				#endif
						
				wait_result = WaitForSingleObject(ov_writefile.hEvent, serial_port_write_data_timeout);
						
				#ifdef _DEBUG_TIME_SHOW_
					std::cerr<<"\n serialPortRwThreadMain WRITE TIME = "<<timeGetTime() - write_data_time<<" ms";
				#endif

				if(wait_result == WAIT_OBJECT_0) 
				{
					if (!GetOverlappedResult(hSerialPort, &ov_writefile, &transmitted_bytes_count, false))	
					{
						CancelIo(hSerialPort);
						hasTransmittedData(0, 2);

						#ifdef _DEBUG_ 
							std::cerr<<"\n serialPortRwThreadMain WriteFile GetOverlappedResult ERROR = "<<GetLastError();
						#endif
					} 
					else // GetOverlappedResult == true
						hasTransmittedData(transmitted_bytes_count, 0);
				}
				else // wait_result != WAIT_OBJECT_0
					{
						CancelIo(hSerialPort);
						hasTransmittedData(0, 1);
						
						#ifdef _DEBUG_ 
							std::cerr<<"\n serialPortRwThreadMain ERROR WRITE TIMEOUT";
						#endif
					}

				#ifdef _RTS_DISABLE_
					EscapeCommFunction(hSerialPort, CLRRTS);
				#endif
			} // end INTERFACE_WRITE_STATE

			/********************INTERFACE_READ_STATE********************/
			if (serial_port_state == INTERFACE_READ_STATE)
			{
				#ifdef _DEBUG_ 
					std::cerr<<"\n serialPortRwThreadMain INTERFACE_READ_STATE";
				#endif

				#ifdef _RTS_DISABLE_
					EscapeCommFunction(hSerialPort, CLRRTS);
				#endif

				read_first_word_ok = false;

				// -     
				//If the overlapped operation cannot be completed immediately, the function returns FALSE and the GetLastError function returns ERROR_IO_PENDING, indicating that the operation is executing in the background.
				SetCommMask(hSerialPort, 0); //O_o   ""    ,  -    ,    "" WaitCommEvent       
				SetCommMask(hSerialPort, EV_RXCHAR);

				#ifdef _DEBUG_TIME_SHOW_ 
					read_data_time = timeGetTime();
				#endif

				if (WaitCommEvent(hSerialPort, &comm_mask, &ov_waitcommevent))
				{
					read_first_word_ok = true;
					#ifdef _DEBUG_ 
						std::cerr<<"\n serialPortRwThreadMain WaitCommEvent finished quickly";
					#endif
				} 
				else // WaitCommEvent == false
					if (GetLastError() == ERROR_IO_PENDING)
					{						
						#ifdef _DEBUG_
							std::cerr<<"\n serialPortRwThreadMain WaitCommEvent PENDING";
						#endif

						wait_result = WaitForSingleObject(ov_waitcommevent.hEvent, serial_port_read_data_timeout);

						#ifdef _DEBUG_TIME_SHOW_
							std::cerr<<"\n serialPortRwThreadMain WaitCommEvent TIME = "<<timeGetTime()-read_data_time<<" ms";
						#endif

						if(wait_result == WAIT_OBJECT_0) read_first_word_ok = true;
						else 
							{
								read_first_word_ok = false;
								CancelIo(hSerialPort);
								hasReceivedData(0, 3);

								#ifdef _DEBUG_
									if(wait_result == WAIT_ABANDONED) std::cerr<<"\n serialPortRwThreadMain WaitCommEvent ERROR WAIT_ABANDONED";
									if(wait_result == WAIT_TIMEOUT) 
									{
										ClearCommError(hSerialPort, &temp_clr_comm, &comstat_clr_comm);
										std::cerr<<"\n serialPortRwThreadMain WaitCommEvent ERROR WAIT_TIMEOUT > "<<serial_port_read_data_timeout<<" ms"<<" cbInQue = "<<comstat_clr_comm.cbInQue;
									}
									if(wait_result == WAIT_FAILED) std::cerr<<"\n serialPortRwThreadMain WaitCommEvent ERROR WAIT_FAILED = "<<GetLastError();
								#endif
							}
					} 
					else // WaitCommEvent GetLastError() != ERROR_IO_PENDING 
						{
							read_first_word_ok = false;
							CancelIo(hSerialPort);
							hasReceivedData(0, 4);

							#ifdef _DEBUG_ 
								std::cerr<<"\n serialPortRwThreadMain WaitCommEvent !ERROR_IO_PENDING GetLastError() = "<<GetLastError();
							#endif
						}

					if (read_first_word_ok) //   read_first_word_ok == false  
					{
						if (!GetOverlappedResult(hSerialPort, &ov_waitcommevent, &temp_var, false))	
						{
							CancelIo(hSerialPort);
							hasReceivedData(0, 4);

							#ifdef _DEBUG_ 
								std::cerr<<"\n serialPortRwThreadMain WaitCommEvent GetOverlappedResult ERROR = "<<GetLastError();
							#endif
						} 
						else // WaitCommEvent GetOverlappedResult == true
							{
								if(!(comm_mask & EV_RXCHAR))
								{					
									CancelIo(hSerialPort);
									hasReceivedData(0, 4);

									#ifdef _DEBUG_ 
										std::cerr<<"\n serialPortRwThreadMain WaitCommEvent !EV_RXCHAR";
									#endif

								} 
								else // EV_RXCHAR
									{
										ClearCommError(hSerialPort, &temp_clr_comm, &comstat_clr_comm);		//   COMSTAT
											
										#ifdef _DEBUG_ 
											std::cerr<<"\n serialPortRwThreadMain WaitCommEvent got first word = "<<comstat_clr_comm.cbInQue;
										#endif
										
										if(comstat_clr_comm.cbInQue)                         			//     
										{		
											read_all_words_ok = false;
	
											if (ReadFile(hSerialPort, recv_command_buf, PACKET_LENGTH_BYTE, NULL, &ov_readfile))
											{
												read_all_words_ok = true;

												#ifdef _DEBUG_ 
													std::cerr<<"\n serialPortRwThreadMain ReadFile finished quickly";
												#endif
											} 
											else // ReadFile == false
												if (GetLastError() == ERROR_IO_PENDING)
												{
													#ifdef _DEBUG_TIME_SHOW_
														std::cerr<<"\n serialPortRwThreadMain READ PENDING";
													#endif
						
													wait_result = WaitForSingleObject(ov_readfile.hEvent, INFINITE);												
						
													#ifdef _DEBUG_TIME_SHOW_ 
														std::cerr<<"\n serialPortRwThreadMain READ TIME = "<<timeGetTime()-read_data_time<<" ms";
													#endif
												
													read_all_words_ok = true;
												} 
												else // ReadFile GetLastError() != ERROR_IO_PENDING
													{
														read_all_words_ok = false;
														CancelIo(hSerialPort);
														hasReceivedData(0, 4);

														#ifdef _DEBUG_ 
															std::cerr<<"\n serialPortRwThreadMain WaitCommEvent !ERROR_IO_PENDING GetLastError() = "<<GetLastError();
														#endif
													}		

											if(read_all_words_ok) //   read_all_words_ok == false  
											{
												if (!GetOverlappedResult(hSerialPort, &ov_readfile, &received_bytes_count, false))
												{
													CancelIo(hSerialPort);
													hasReceivedData(0, 4);

													#ifdef _DEBUG_ 
														std::cerr<<"\n serialPortRwThreadMain ReadFile GetOverlappedResult ERROR = "<<GetLastError();
													#endif
												} 
												else // ReadFile GetOverlappedResult == true
													{
														hasReceivedData(received_bytes_count, 0);		
													}
											}
										} 
										else // comstat_clr_comm.cbInQue == 0
											{
												CancelIo(hSerialPort);
												hasReceivedData(0, 4);

												#ifdef _DEBUG_ 
													std::cerr<<"\n serialPortRwThreadMain WaitCommEvent got ZERO :(";
												#endif						
											} 
									}
							}
					}
			} // end INTERFACE_READ_STATE
		} // end ReadWriteDataEvent
	} // end while
	
	std::cerr<<"\n THREAD EXIT";
	
	return 0;
}

//*************************************************************
//*******************Serial*port*******************************
//*************************************************************

bool writeSerialPortData()
{
	bool transmit_ok = false;

	if(PurgeComm(hSerialPort, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR))
	{
		if (WriteFile(hSerialPort, send_command_buf, PACKET_LENGTH_BYTE, NULL, &ov_writefile))
		{
			transmit_ok = true;
			#ifdef _DEBUG_ 
				std::cerr<<"\n writeSerialPortData WriteFile finished quickly";
			#endif
		}
		else
			if (GetLastError() == ERROR_IO_PENDING)
			{
				transmit_ok = true;
				#ifdef _DEBUG_ 
					std::cerr<<"\n writeSerialPortData WRITE PENDING";
				#endif
			} 
			else 
				{
					transmit_ok = false;
					#ifdef _DEBUG_ 
						std::cerr<<"\n writeSerialPortData WRITE !ERROR_IO_PENDING GetLastError() = "<<GetLastError();
					#endif
				}
	}
	else
		{
			transmit_ok = false;
			#ifdef _DEBUG_ 
				std::cerr<<"\n writeSerialPortData error !PurgeComm";
			#endif
		}

	if (transmit_ok)
	{
		serial_port_state = INTERFACE_WRITE_STATE;
		SetEvent(hReadWriteDataEvent);
	}
	else
		{
			serial_port_state = INTERFACE_IDLE_STATE;			
			CancelIo(hSerialPort);
		}

	return transmit_ok;
}

_DLLAPI int a100GetSerialPortCurrentState() 
{
	return serial_port_state;
}

_DLLAPI int a100SendCommand(unsigned char receiver_address, unsigned char sender_address, unsigned char command_code, BYTE command_param, unsigned char data_array[], int write_timeout, int read_timeout, pA100CallBackFunc a100CallBackFunc)
{
	if (serial_port_state != INTERFACE_IDLE_STATE) 
	{
		//std::cerr<<"\n sendCommand error serial_port_state != INTERFACE_IDLE_STATE";
		return 1;
	}

	if (data_array == NULL)
	{
		//std::cerr<<"\n sendCommand error data_array";
		return 2;
	}

	a100_sended_command_var.dest = receiver_address;
	a100_sended_command_var.source = sender_address;
	a100_sended_command_var.code = command_code;
	a100_sended_command_var.param = command_param;
	memcpy(a100_sended_command_var.data, data_array, DATA_COUNT_BYTE);

	if (!a100CommandToBuffer(send_command_buf, a100_sended_command_var)) 
	{
		//std::cerr<<"\n sendCommand a100CommandToBuffer error";
		return 3;
	}

	userCallBackFunc = a100CallBackFunc;

	serial_port_read_data_timeout = read_timeout;
	serial_port_write_data_timeout = write_timeout;

	if (!writeSerialPortData())
	{
		//std::cerr<<"\n sendCommand io handler error ";
		return 4;
	}

	return 0;
}

_DLLAPI void a100CloseSerialPort()
{
	if (serial_port_state == INTERFACE_CLOSE_STATE) return;

	serial_port_state = INTERFACE_CLOSE_STATE;

	// Stop Thread
	SetEvent(hReadWriteDataEvent); //     .

	DWORD result = WaitForSingleObject(hRwThread, rwthread_stop_wait);
	if (result != WAIT_OBJECT_0)
	{
		TerminateThread(hRwThread, 0);
		std::cerr<<"\n !!! closeInterface thread is terminated !!!";
	}

	CancelIo(hSerialPort);
	std::cerr<<"\n closeInterface I/O is canceled";

	CloseHandle(hRwThread);
	CloseHandle(hReadWriteDataEvent);

	// SerialPort Parameters Restore
	PurgeComm(hSerialPort, PURGE_TXABORT | PURGE_RXABORT);
	PurgeComm(hSerialPort, PURGE_TXCLEAR | PURGE_RXCLEAR);

	SetCommMask(hSerialPort, serial_port_old_evt_mask);
	SetCommState(hSerialPort, &serial_port_old_param);
	SetCommTimeouts(hSerialPort, &serial_port_old_timeouts);

	#ifdef _RTS_DISABLE_
		EscapeCommFunction(hSerialPort, CLRRTS);
	#endif


	CloseHandle(ov_waitcommevent.hEvent);
	CloseHandle(ov_readfile.hEvent);
	CloseHandle(ov_writefile.hEvent);

	CloseHandle(hSerialPort);

	std::cerr<<"\n interface has been closed";
}

_DLLAPI bool a100OpenSerialPort(const std::string &interface_name, const int &interface_speed)
{
	if (interface_name.empty()) return false;

	a100CloseSerialPort();

	//Asynchronous WaitCommEvent
	//If the overlapped operation cannot be completed immediately, the function returns FALSE and
	//the GetLastError function returns ERROR_IO_PENDING, indicating that the operation is executing in the background.
	//When this happens, the system sets the hEvent member of the OVERLAPPED structure to the not-signaled state
	//before WaitCommEvent returns, and then it sets it to the signaled state when one of the specified events occurs.
	//    - .        ..      WaitCommEvent.
	ov_waitcommevent.Internal		= 0;
	ov_waitcommevent.InternalHigh	= 0;
	ov_waitcommevent.Offset			= 0;
	ov_waitcommevent.OffsetHigh		= 0;
	//The system closes the handle automatically when the process terminates
	ov_waitcommevent.hEvent			= CreateEvent(NULL,    // default security attribute
	   	   	   	   	   	  	  	  	  	  	  	  true,    // manual-reset event
	   	   	   	   	   	  	  	  	  	  	  	  true,	   // initial state = signaled  true     ,      .    ,      ,  ,   WaitCommEvent,     .
	   	   	   	   	   	  	  	  	  	  	  	  NULL);   // unnamed event object

	//Asynchronous WriteFile
    //Functions such as ReadFile and WriteFile set this handle to the nonsignaled state before they begin an I/O operation.
    //When the operation has completed, the handle is set to the signaled state.
	//    - .        ..      ReadFile and WriteFile.
	ov_writefile.Internal		= 0;
	ov_writefile.InternalHigh	= 0;
	ov_writefile.Offset			= 0;
	ov_writefile.OffsetHigh		= 0;
	//The system closes the handle automatically when the process terminates
	ov_writefile.hEvent			= CreateEvent(NULL,	     // default security attribute
		       	   	   	   	   	   	   	   	  true,   	 // manual-reset event
		       	   	   	   	   	   	   	   	  true, 	 // initial state = signaled
		       	   	   	   	   	   	   	   	  NULL); 	 // unnamed event object
	ov_readfile.Internal		= 0;
	ov_readfile.InternalHigh	= 0;
	ov_readfile.Offset			= 0;
	ov_readfile.OffsetHigh		= 0;
	//The system closes the handle automatically when the process terminates
	ov_readfile.hEvent			= CreateEvent(NULL,    	// default security attribute
	   	   	   	   	   	  	  	  	  	  	  true,    	// manual-reset event
	   	   	   	   	   	  	  	  	  	  	  true,  	// initial state = signaled
	   	   	   	   	   	  	  	  	  	  	  NULL);  	// unnamed event object

	// "" COM   Windows,    >=10
	std::string system_port_name = std::string("\\\\.\\") + interface_name;

	hSerialPort = CreateFileA(system_port_name.c_str(),
							  GENERIC_READ|GENERIC_WRITE,
							  0,	//  
							  NULL,	//    
							  OPEN_EXISTING,
							  FILE_FLAG_OVERLAPPED,
							  NULL);

	if(hSerialPort == INVALID_HANDLE_VALUE)
	{
		std::cerr<<"\n openInterface INVALID_HANDLE_VALUE";
		hSerialPort = 0;
		return false;
	}

	//        
	if(!PurgeComm(hSerialPort, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR))
	{
		std::cerr<<"\n openInterface !PurgeComm";
		CloseHandle(hSerialPort);
		return false;
	}

    //         .
	if(!GetCommMask(hSerialPort, &serial_port_old_evt_mask))
	{
		std::cerr<<"\n openInterface !GetCommMask";
		CloseHandle(hSerialPort);
		return false;
	}

	//   ,      
	if(!GetCommState(hSerialPort, &serial_port_old_param))
	{
		std::cerr<<"\n openInterface !GetCommState";
		CloseHandle(hSerialPort);
		return false;
	}

	//               .
	if(!GetCommTimeouts(hSerialPort, &serial_port_old_timeouts))
	{
		std::cerr<<"\n openInterface !GetCommTimeouts";
		CloseHandle(hSerialPort);
		return false;
	}

	// 
	serial_port_new_param.DCBlength				= sizeof(serial_port_new_param);	// sizeof(DCB)
	serial_port_new_param.BaudRate				= interface_speed; 					// baud rate
	serial_port_new_param.fBinary				= true;								// binary mode, always true
	serial_port_new_param.fParity				= false;							// no parity checking
	serial_port_new_param.fOutxCtsFlow			= false;							// no CTS output flow control
	serial_port_new_param.fOutxDsrFlow			= false;							// no DSR output flow control
	serial_port_new_param.fDtrControl			= DTR_CONTROL_DISABLE;				// DTR flow control type (2)
	serial_port_new_param.fDsrSensitivity		= false;							// DSR sensitivity
	serial_port_new_param.fTXContinueOnXoff		= true;								// XOFF continues Tx
	serial_port_new_param.fOutX					= false;							// no XON/XOFF out flow control
	serial_port_new_param.fInX					= false;							// no XON/XOFF in flow control
	serial_port_new_param.fErrorChar			= false;							// no error replacement
	serial_port_new_param.fNull					= false;							// no null stripping
	#ifdef _RTS_DISABLE_
		serial_port_new_param.fRtsControl			= RTS_CONTROL_DISABLE;				// RTS flow control
	#endif 
	#ifndef _RTS_DISABLE_
		serial_port_new_param.fRtsControl			= RTS_CONTROL_TOGGLE;				// RTS flow control
	#endif	
	serial_port_new_param.fAbortOnError			= false;							// no aborts of reads/writes on error
	serial_port_new_param.wReserved				= 0;								// not currently used
	serial_port_new_param.ByteSize				= 8;								// number of bits/unsigned char, 4-8
	serial_port_new_param.Parity				= NOPARITY;							// no parity checking
	serial_port_new_param.StopBits				= ONESTOPBIT;						// ONESTOPBIT;// 0,1,2 = 1, 1.5, 2

	//        
	serial_port_new_timeouts.ReadIntervalTimeout         = 15; 				//      ,        
	serial_port_new_timeouts.ReadTotalTimeoutMultiplier  = 0;
	serial_port_new_timeouts.ReadTotalTimeoutConstant    = 0;				//  ,       
	serial_port_new_timeouts.WriteTotalTimeoutMultiplier = 0;
	serial_port_new_timeouts.WriteTotalTimeoutConstant   = 0;				//  ,       

	//  ,   
	if(!SetupComm(hSerialPort, 0xFFFE, 0xFFFE))
	{
		std::cerr<<"\n openInterface !SetupComm";
		CloseHandle(hSerialPort);
		return false;
	}

	//    
	if(!SetCommState   (hSerialPort, &serial_port_new_param))
	{
		std::cerr<<"\n openInterface !SetCommState";
		CloseHandle(hSerialPort);
		return false;
	}

	// 
	if(!SetCommTimeouts(hSerialPort, &serial_port_new_timeouts))
	{
		std::cerr<<"\n openInterface !SetCommTimeouts";
		CloseHandle(hSerialPort);
		return false;
	}

	//         
	if(!SetCommMask(hSerialPort, EV_RXCHAR))
	{
		std::cerr<<"\n openInterface !SetCommMask";
		CloseHandle(hSerialPort);
		return false;
	}

	//   ,          
	if(!ClearCommError(hSerialPort, NULL, NULL))
	{
		std::cerr<<"\n openInterface !ClearCommError";
		CloseHandle(hSerialPort);
		return false;
	}

	#ifdef _RTS_DISABLE_
	if (!EscapeCommFunction(hSerialPort, CLRRTS))
	{
		std::cerr<<"\n openInterface !EscapeCommFunction CLRRTS";
		CloseHandle(hSerialPort);
		return false;
	}
	#endif

	serial_port_state = INTERFACE_IDLE_STATE;

	//RW THREAD SECTION
	//The system closes the handle automatically when the process terminates
	hReadWriteDataEvent = CreateEvent(NULL,    // default security attribute
 	  	  	  	  	  	  	  	  	  true,    // manual-reset event
 	  	  	  	  	  	  	  	  	  false,   // initial state = signaled
 	  	  	  	  	  	  	  	  	  NULL);   // unnamed event object

	hRwThread = CreateThread(NULL, 0, serialPortRwThreadMain, NULL, 0, &idRwThread);

	if(hRwThread == NULL)
	{
		std::cerr<<"\n openInterface !CreateThread";

		serial_port_state = INTERFACE_CLOSE_STATE;

		CloseHandle(hReadWriteDataEvent);

		CloseHandle(hSerialPort);
		return false;
	}

	//std::cerr<<"\n interface has been opened";

	return true;
}

/********************************************************************************************************/
/*********************************************Global*DLL*section*****************************************/
/********************************************************************************************************/
/*
// Begin the shared data segment.
#pragma data_seg("SHARED")

// Define and INITIALIZE simple variables, integers, char[] arrays and pointers
// Do not define classes that require 'deep' copy constructors.
int shared_dll_var = 0;

// End the shared data segment and default back to the normal data segment behavior.
#pragma data_seg()

// This tells the linker to generate the shared data segment.  
// It does not tell it what variables are shared, the other statements do that,
// but it does direct the linker to make provisions for the shared data segment.
#pragma comment(linker, "/section:SHARED,RWS")

_DLLAPI int dll_var = 0;

_DLLAPI void setSharedVar(int temp_arg)
{
	shared_dll_var = temp_arg;
}

_DLLAPI int getSharedVar()
{
	return shared_dll_var;
}

_DLLAPI void printStrFunc()
{
	MessageBox(NULL, TEXT("DLL printStrFunc()"), TEXT("DLL"),MB_OK);
}

_DLLAPI int sendCommand(int (*pFunc)(int), int pfunc_arg)
{
	shared_dll_var+=1;
	std::cerr<<"\nshared_dll_var = "<<shared_dll_var<<"\n";

	return pFunc(pfunc_arg);
}
*/
